=== debian/changelog ===
soci (4.0.3-1) unstable; urgency=medium

  * New upstream version 4.0.3.  Closes: 1017148
  * Remove unneeded libdir patch
  * Update missing source for bootstrap.js
  * Remove unused override
  * Update dh compat to v13
  * Update standards version (no changes)
  * Add lintian overrides for missing source on html docs (false positive)

 -- William Blough <bblough@debian.org>  Sat, 24 Sep 2022 21:07:08 -0400
