=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed -Wl,-z,now

%:
	dh $@ --buildsystem=cmake

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DSOCI_EMPTY:BOOLEAN=OFF \
		-DSOCI_CXX11=1

override_dh_auto_test:
	# Run test, but for now, ignore results. (to be fixed later...)
	-dh_auto_test
